searchNodes=[{"doc":"","ref":"VirtualFieldsFiller.html","title":"VirtualFieldsFiller","type":"behaviour"},{"doc":"","ref":"VirtualFieldsFiller.html#fill_virtual_fields/1","title":"VirtualFieldsFiller.fill_virtual_fields/1","type":"function"},{"doc":"","ref":"VirtualFieldsFiller.html#c:fill_virtual_fields/1","title":"VirtualFieldsFiller.fill_virtual_fields/1","type":"callback"},{"doc":"","ref":"VirtualFieldsFiller.html#is_struct_or_list_of_structs/1","title":"VirtualFieldsFiller.is_struct_or_list_of_structs/1","type":"macro"},{"doc":"Virtual Fields Filler Fill the virtual fields for your Ecto structs and nested structs recursively. In your Schema, add the fill_virtual_fields/1 function: defmodule MyApp.User do @behaviour VirtualFieldsFiller use Ecto.Schema alias __MODULE__ schema &quot;users&quot; do field(:first_name, :string) field(:last_name, :string) field(:full_name, :string, virtual: true) timestamps(type: :utc_datetime) end def fill_virtual_fields(%User{} = user) do first_name = Map.fetch!(user, :first_name) last_name = Map.fetch!(user, :last_name) Map.put(user, :full_name, &quot;\#{first_name} \#{last_name}&quot;) end end Then, after fetching a user (or list of users) from your DB, call VirtualFieldsFiller.fill_virtual_fields/1: import VirtualFieldsFiller User |&gt; Repo.get!(id) |&gt; fill_virtual_fields() If you use QueryBuilder, you may organize your code as follows: # in your controller: Blog.get_article_by_id(article_id, preload: [:category, comments: :user]) # in the Blog context def get_article_by_id(id, opts \\\\ []) do QueryBuilder.where(Article, id: id) |&gt; QueryBuilder.from_list(opts) |&gt; Repo.one!() |&gt; fill_virtual_fields() end As QueryBuilder encourages to pass the association names that needs to be preloaded to the Context function, you may call fill_virtual_fields/1 in the Context function, right after the call to the Repo function, so that any nested struct gets its virtual fields filled.","ref":"readme.html","title":"Virtual Fields Filler","type":"extras"},{"doc":"Add virtual_fields_filler for Elixir as a dependency in your mix.exs file: def deps do [ {:virtual_fields_filler, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"Virtual Fields Filler - Installation","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/virtual_fields_filler.","ref":"readme.html#hexdocs","title":"Virtual Fields Filler - HexDocs","type":"extras"}]